#include "LLRDemodulation.h"


void LLRDemodulationSetConfig(int config_addr, int input_addr, int gain_mmse_input,int temp_Q_output,int temp_reciprocalNoiseVar_output,int output_addr,int Qm, int ReNum)
{
	int *para = (int *)config_addr;
	para[0] = (ReNum + 31)>>5;
	para[10] = 1;
	para[11] = 1;
	para[12] = 1;
	para[13] = 1;
	if(Qm ==2)
	{
		para[10] = 0;
		para[16*10+4] =0x20;
		para[16*10+13] =(0x1<<24)+(0x20<<16) + 0x6;
		para[16*10+14] = 0xffffffff;
		para[16*10+15] = 0x0;

	}
	else if(Qm == 4)
	{
		para[11] = 0;
		para[16*10+4] =0x40;
		para[16*10+13] =(0x1<<24)+(0x40<<16) + 0x6;
		para[16*10+14] = 0xffffffff;
		para[16*10+15] = 0xffffffff;
	}
	else if(Qm == 6)
	{
		para[12] = 0;
		para[16*10+4] =0x30;
		para[16*10+13] =(0x1<<24)+(0x30<<16) + 0x6;
		para[16*10+14] = 0xffffffff;
		para[16*10+15] = 0x0000ffff;

	}
	else if(Qm == 8)
	{
		para[13] = 0;
		para[16*10+4] =0x40;
		para[16*10+13] =(0x1<<24)+(0x40<<16) + 0x6;
		para[16*10+14] = 0xffffffff;
		para[16*10+15] = 0xffffffff;
	}
	para[16*1] = gain_mmse_input;
	para[16*1+12] = ReNum<<1;
	para[16*2] = temp_Q_output;
	para[16*2+12] = ReNum<<1;

	para[16*8] = temp_reciprocalNoiseVar_output;
	para[16*8+12] =ReNum;

	para[16*9] = input_addr;
	para[16*9+12] =ReNum;

	para[16*10] = output_addr;
	para[16*10+12] =ReNum*Qm;




}
