#ifndef PHY_STRUCT_H
#define PHY_STRUCT_H

#include <type_define.h>

typedef enum
{
    FAPI_SLOT_INDICATION = 0x82,
    L1FAPIMSGID_E_CNT
}L1FAPIMsgId_e;



typedef struct
{
    uint8_t msgNum;
    uint8_t cellIndex;
    uint16_t rev;
}L1MsgHdr_t;


/**@brief L1 General Msg Head*/
typedef struct
{
    L1FAPIMsgId_e msgId;
    uint32_t msgSize;
}L1GeneralMsgHdr_t;


/**@brief Slot indication*/
typedef struct
{
    uint16_t SFN;
    uint16_t Slot;
}L1SlotIndication_t;

#endif